var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);

// index.ts
var casualos_cli_exports = {};
__export(casualos_cli_exports, {
  RecordsClient: () => RecordsClient
});
module.exports = __toCommonJS(casualos_cli_exports);

// ../aux-records/RecordsClient.js
var __awaiter = function(thisArg, _arguments, P, generator) {
  function adopt(value) {
    return value instanceof P ? value : new P(function(resolve) {
      resolve(value);
    });
  }
  return new (P || (P = Promise))(function(resolve, reject) {
    function fulfilled(value) {
      try {
        step(generator.next(value));
      } catch (e) {
        reject(e);
      }
    }
    function rejected(value) {
      try {
        step(generator["throw"](value));
      } catch (e) {
        reject(e);
      }
    }
    function step(result) {
      result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected);
    }
    step((generator = generator.apply(thisArg, _arguments || [])).next());
  });
};
var __await = function(v) {
  return this instanceof __await ? (this.v = v, this) : new __await(v);
};
var __asyncGenerator = function(thisArg, _arguments, generator) {
  if (!Symbol.asyncIterator)
    throw new TypeError("Symbol.asyncIterator is not defined.");
  var g = generator.apply(thisArg, _arguments || []), i, q = [];
  return i = {}, verb("next"), verb("throw"), verb("return", awaitReturn), i[Symbol.asyncIterator] = function() {
    return this;
  }, i;
  function awaitReturn(f) {
    return function(v) {
      return Promise.resolve(v).then(f, reject);
    };
  }
  function verb(n, f) {
    if (g[n]) {
      i[n] = function(v) {
        return new Promise(function(a, b) {
          q.push([n, v, a, b]) > 1 || resume(n, v);
        });
      };
      if (f)
        i[n] = f(i[n]);
    }
  }
  function resume(n, v) {
    try {
      step(g[n](v));
    } catch (e) {
      settle(q[0][3], e);
    }
  }
  function step(r) {
    r.value instanceof __await ? Promise.resolve(r.value.v).then(fulfill, reject) : settle(q[0][2], r);
  }
  function fulfill(value) {
    resume("next", value);
  }
  function reject(value) {
    resume("throw", value);
  }
  function settle(f, v) {
    if (f(v), q.shift(), q.length)
      resume(q[0][0], q[0][1]);
  }
};
var RecordsClient = class {
  get sessionKey() {
    return this._sessionKey;
  }
  set sessionKey(value) {
    this._sessionKey = value;
  }
  get endpoint() {
    return this._endpoint;
  }
  constructor(endpoint) {
    this._endpoint = endpoint;
    this._sessionKey = null;
    Object.defineProperties(this, {
      then: {
        value: void 0,
        configurable: false,
        writable: false
      },
      catch: {
        value: void 0,
        configurable: false,
        writable: false
      }
    });
  }
  /**
   * Calls the procedure with the given name, using the given argument.
   * @param name The name of the procedure to call.
   * @param input The input to the procedure.
   * @param options The options to use for the procedure.
   */
  callProcedure(name, input, options) {
    var _a, _b, _c, _d;
    return __awaiter(this, void 0, void 0, function* () {
      const response = yield fetch(`${(_a = options === null || options === void 0 ? void 0 : options.endpoint) !== null && _a !== void 0 ? _a : this._endpoint}/api/v3/callProcedure`, {
        method: "POST",
        body: JSON.stringify({ procedure: name, input }),
        headers: Object.assign(Object.assign({ "Content-Type": "application/json;charset=UTF-8", Accept: "application/json,application/x-ndjson" }, (_b = options === null || options === void 0 ? void 0 : options.headers) !== null && _b !== void 0 ? _b : {}), this._authenticationHeaders(options))
      });
      if (((_d = (_c = response.headers) === null || _c === void 0 ? void 0 : _c.get("Content-Type")) === null || _d === void 0 ? void 0 : _d.indexOf("application/x-ndjson")) >= 0) {
        return streamJsonLines(response.body, new TextDecoder());
      } else {
        return yield response.json();
      }
    });
  }
  _authenticationHeaders(options) {
    var _a;
    const key = (_a = options === null || options === void 0 ? void 0 : options.sessionKey) !== null && _a !== void 0 ? _a : this._sessionKey;
    if (key) {
      return {
        Authorization: `Bearer ${key}`
      };
    } else {
      return {};
    }
  }
};
function streamJsonLines(stream, decoder) {
  return __asyncGenerator(this, arguments, function* streamJsonLines_1() {
    let buffer = "";
    const reader = stream.getReader();
    while (true) {
      const { done, value } = yield __await(reader.read());
      if (done) {
        if (buffer.length > 0) {
          return yield __await(JSON.parse(buffer));
        }
        break;
      }
      let chunk = decoder.decode(value, { stream: true });
      let newlinePosition;
      while ((newlinePosition = chunk.indexOf("\n")) >= 0) {
        let carriageReturnPosition = chunk.indexOf("\r", newlinePosition - 1);
        if (carriageReturnPosition >= 0) {
          const beforeCarriageReturn = chunk.substring(0, carriageReturnPosition);
          if (buffer.length + beforeCarriageReturn.length > 0) {
            const jsonLine = buffer + beforeCarriageReturn;
            yield yield __await(JSON.parse(jsonLine));
          }
          const afterNewline = chunk.substring(carriageReturnPosition + 2);
          chunk = afterNewline;
          buffer = "";
        } else {
          const beforeNewline = chunk.substring(0, newlinePosition);
          if (buffer.length + beforeNewline.length > 0) {
            const jsonLine = buffer + beforeNewline;
            yield yield __await(JSON.parse(jsonLine));
          }
          const afterNewline = chunk.substring(newlinePosition + 1);
          chunk = afterNewline;
          buffer = "";
        }
      }
      buffer += chunk;
    }
  });
}
// Annotate the CommonJS export names for ESM import in node:
0 && (module.exports = {
  RecordsClient
});
